// EvCaller.h : Declaration of the CEventCaller

#ifndef __EVENTCALLER_H_
#define __EVENTCALLER_H_

#include "resource.h"       // main symbols
#pragma warning(disable:4786)
#include <vector>
#include <string>
#include "EventCallerCP.h"

/////////////////////////////////////////////////////////////////////////////
// CEventCaller
class ATL_NO_VTABLE CEventCaller : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CEventCaller, &CLSID_EventCaller>,
	public IConnectionPointContainerImpl<CEventCaller>,
	public IEventCaller,
	public CProxyIEventCallerEvents< CEventCaller >
{
public:
	CEventCaller();

	HRESULT FinalConstruct();
	void FinalRelease();

DECLARE_REGISTRY_RESOURCEID(IDR_EVENTCALLER)
DECLARE_NOT_AGGREGATABLE(CEventCaller)
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CEventCaller)
	COM_INTERFACE_ENTRY(IEventCaller)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CEventCaller)
CONNECTION_POINT_ENTRY(IID_IEventCallerEvents)
END_CONNECTION_POINT_MAP()

// IEventCaller
public:
	HRESULT STDMETHODCALLTYPE Start();
	HRESULT STDMETHODCALLTYPE Stop();
	STDMETHOD(SetConnectionString)(BSTR ConnectionString);

public:
	typedef std::vector< std::wstring > strv_t;
	typedef std::vector< long > longv_t;

private:

private:
	CComBSTR m_sConnectionString;
	// Reload event settings from DB.
	HRESULT Reset(strv_t &, longv_t &);
	// Execute one event cycle - up to RELOAD_SCHEDULE event.
	HRESULT RaiseEvents();
	// Event thread function.
	static DWORD WINAPI EventFunc(LPVOID pParam);

private:
	unsigned char m_bStarted:1; // If true, object raise events.
	unsigned char m_bLeaveThreads:1; // flag to gracefully leave worker threads.

	CRITICAL_SECTION m_cs;

	HANDLE m_hEventThread;// Event thread handle.
};

#endif //__EVENTCALLER_H_
