// SchedEdit.cpp : Implementation of CScheduleEditor
#include "stdafx.h"
#include "ScheduleEditor.h"
#include "SchedEdit.h"

LPCWSTR pszCmdEdit = L"exec spEdit ";
LPCWSTR pszCmdDelete = L"delete from schedule where signal='";

/////////////////////////////////////////////////////////////////////////////
// CScheduleEditor
HRESULT CScheduleEditor::Activate()
{
	HRESULT hr = GetObjectContext(&m_spObjectContext);
	if (SUCCEEDED(hr))
		return S_OK;
	return hr;
} 

BOOL CScheduleEditor::CanBePooled()
{
	return FALSE;
} 

void CScheduleEditor::Deactivate()
{
	m_spObjectContext.Release();
} 

STDMETHODIMP CScheduleEditor::EditSchedule(BSTR ConnectionString, BSTR SignalName, long RepeatTime)
{
	HRESULT hr = S_OK;
	CComPtr<_Connection> pCnn;
	try
	{
		hr = pCnn.CoCreateInstance(__uuidof(Connection));
		if (FAILED(hr))
			_com_issue_error(hr);
		ATLASSERT(pCnn != NULL);
		hr = pCnn->Open(CComBSTR(ConnectionString), NULL, NULL, 0);
		if (FAILED(hr))
			_com_issue_error(hr);
		

		CComBSTR bsCmd;
		if (RepeatTime > 0)
			bsCmd = pszCmdEdit;
		else
			bsCmd = pszCmdDelete;
		bsCmd.Append(SignalName);
		if (RepeatTime > 0)
		{
			CComVariant vrtm(RepeatTime);
			hr = vrtm.ChangeType(VT_BSTR);
			if (FAILED(hr))
				_com_issue_error(hr);
			bsCmd.Append(",");
			bsCmd.Append(vrtm.bstrVal);
		}
		else
			bsCmd.Append("'");
		hr = pCnn->Execute(bsCmd, NULL, 0, NULL);
	}
	catch (_com_error e)      
	{
		hr = e.Error();
	}
	catch (...)      
	{
		hr = E_FAIL;
	}

	if (pCnn != NULL)
	{
		pCnn->Close();
		pCnn.Release();
	}

	if (m_spObjectContext != NULL)
	{
		if(SUCCEEDED(hr))
			m_spObjectContext->SetComplete();
		else
			m_spObjectContext->SetAbort();
	}
	return hr;
}

