// SchedEdit.h : Declaration of the CScheduleEditor

#ifndef __SCHEDULEEDITOR_H_
#define __SCHEDULEEDITOR_H_

#include "resource.h"       // main symbols
#include <mtx.h>

/////////////////////////////////////////////////////////////////////////////
// CScheduleEditor
class ATL_NO_VTABLE CScheduleEditor : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CScheduleEditor, &CLSID_ScheduleEditor>,
	public IObjectControl,
	public IDispatchImpl<IScheduleEditor, &IID_IScheduleEditor, &LIBID_ScheduleEditor>
{
public:
	CScheduleEditor(){}

DECLARE_REGISTRY_RESOURCEID(IDR_SCHEDULEEDITOR)
DECLARE_PROTECT_FINAL_CONSTRUCT()
DECLARE_NOT_AGGREGATABLE(CScheduleEditor)

BEGIN_COM_MAP(CScheduleEditor)
	COM_INTERFACE_ENTRY(IScheduleEditor)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// IScheduleEditor
public:
	STDMETHOD(EditSchedule)(BSTR ConnectionString, BSTR SignalName, long RepeatTime);
};

#endif //__SCHEDULEEDITOR_H_
